#include <SparkFunTSL2561.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BME280.h>

#define BME_SCK 13
#define BME_MISO 12
#define BME_MOSI 11
#define BME_CS 10

#define SEALEVELPRESSURE_HPA (1013.25)
SFE_TSL2561 light;
boolean gain; 
unsigned int ms; 
Adafruit_BME280 bme(BME_CS);
unsigned long delayTime;

void setup() {
    Serial.begin(9600);
    while(!Serial);    // time to get serial running
    Serial.println(F("BME280 test"));
    Serial.println("TSL2561 test");

    unsigned status;
    status = bme.begin();  
    light.begin();
    if (!status) {
        Serial.println("Could not find a valid BME280 sensor, check wiring, address, sensor ID!");
        Serial.print("SensorID was: 0x"); Serial.println(bme.sensorID(),16);
        Serial.print("        ID of 0xFF probably means a bad address, a BMP 180 or BMP 085\n");
        Serial.print("   ID of 0x56-0x58 represents a BMP 280,\n");
        Serial.print("        ID of 0x60 represents a BME 280.\n");
        Serial.print("        ID of 0x61 represents a BME 680.\n");
        while (1);
    }
    
    
    Serial.println("-- Default Test --");
    delayTime = 1000;

    Serial.println();
      unsigned char ID;
  
  if (light.getID(ID))
  {
    Serial.print("Got factory ID: 0X");
    Serial.print(ID,HEX);
    Serial.println(", should be 0X5X");
  }

  else
  {
    byte error = light.getError();
   // printError(error);
  }


  gain = 0;

  unsigned char time = 2;

  
  Serial.println("Set timing...");
  light.setTiming(gain,time,ms);
  
  Serial.println("Powerup...");
  light.setPowerUp();

}

void loop() {
    printValues();
    delay(delayTime);
  delay(ms);


  unsigned int data0, data1;
  
  if (light.getData(data0,data1))
  {
    
    //Serial.print("data0: ");
    //Serial.print(data0);
    //Serial.print(" data1: ");
    //Serial.print(data1);
  
  
    double lux; 
    boolean good; 
    

    good = light.getLux(gain,ms,data0,data1,lux);
    
  
    Serial.print("C");
    Serial.println(lux);                      // doorsturen naar pi
    //if (good) Serial.println(" (good)"); else Serial.println(" (BAD)");
  //}
  //else
  //{


    byte error = light.getError();
   // printError(error);
  }
}

/*void printError(byte error)

{
  Serial.print("I2C error: ");
  Serial.print(error,DEC);
  Serial.print(", ");
  
  switch(error)
  {
    case 0:
      Serial.println("success");
      break;
    case 1:
      Serial.println("data too long for transmit buffer");
      break;
    case 2:
      Serial.println("received NACK on address (disconnected?)");
      break;
    case 3:
      Serial.println("received NACK on data");
      break;
    case 4:
      Serial.println("other error");
      break;
    default:
      Serial.println("unknown error");
  }
}*/

void printValues() {
    Serial.print("A");
    Serial.println(bme.readTemperature());          // doorsturen naar pi
    //Serial.println(" *C");
    
    //Serial.print("Pressure = ");
    //Serial.print(bme.readPressure() / 100.0F);
    //Serial.println(" hPa");

    //Serial.print("Approx. Altitude = ");
    //Serial.print(bme.readAltitude(SEALEVELPRESSURE_HPA));
    //Serial.println(" m");

    Serial.print("B");
    Serial.println(bme.readHumidity());           // doorsturen naar pi
    //Serial.println(" %");

    //Serial.println();
}
